BEGIN;
--
-- Create model Grp
--
CREATE TABLE "grp" ("id" bigint NOT NULL PRIMARY KEY, "name" varchar(128) NOT NULL, "description" varchar(1024) NOT NULL);
--
-- Create model Node
--
CREATE TABLE "node" ("id" bigint NOT NULL PRIMARY KEY, "name" varchar(128) NOT NULL, "description" varchar(1024) NULL, "connection" varchar(1024) NULL);
--
-- Create model Rexcore
--
CREATE TABLE "rexcore" ("id" bigint NOT NULL PRIMARY KEY, "name" varchar(128) NOT NULL, "description" varchar(1024) NULL, "connection" varchar(1024) NOT NULL, "username" varchar(1024) NOT NULL, "password" varchar(1024) NULL);
--
-- Create model Tblspace
--
CREATE TABLE "tblspace" ("id" bigint NOT NULL PRIMARY KEY, "name" varchar(32) NOT NULL, "partition" varchar(32) NOT NULL);
--
-- Create model Signal
--
CREATE TABLE "signal" ("id" bigint NOT NULL PRIMARY KEY, "name" varchar(128) NOT NULL, "description" varchar(1024) NOT NULL, "type" varchar(32) NOT NULL, "unit" varchar(32) NULL, "decimals" bigint NOT NULL, "aggregation" bigint NOT NULL, "connection" varchar(1024) NULL, "comment" varchar(1024) NULL, "rex_value_path" varchar(1024) NULL, "rex_trend_path" varchar(1024) NULL, "range_min" double precision NULL, "range_max" double precision NULL, "node_id" bigint NOT NULL, "rexcore_id" bigint NULL, "tblspace_id" bigint NOT NULL);
--
-- Create model Datatbl
--
CREATE TABLE "datatbl" ("id" double precision NOT NULL PRIMARY KEY, "date_from" date NOT NULL, "date_to" date NULL, "name" varchar(32) NOT NULL, "tblspace_id" bigint NOT NULL);
---
-- Create model SignalGrp
--
CREATE TABLE "signal_grp" ("signal_id" bigint NOT NULL PRIMARY KEY, "grp_id" bigint NOT NULL);
--
-- Add field groups to signal
--
ALTER TABLE "signal" ADD CONSTRAINT "signal_node_id_676fb766_fk_node_id" FOREIGN KEY ("node_id") REFERENCES "node" ("id") DEFERRABLE INITIALLY DEFERRED;
ALTER TABLE "signal" ADD CONSTRAINT "signal_rexcore_id_35df7551_fk_rexcore_id" FOREIGN KEY ("rexcore_id") REFERENCES "rexcore" ("id") DEFERRABLE INITIALLY DEFERRED;
ALTER TABLE "signal" ADD CONSTRAINT "signal_tblspace_id_285afc6f_fk_tblspace_id" FOREIGN KEY ("tblspace_id") REFERENCES "tblspace" ("id") DEFERRABLE INITIALLY DEFERRED;
CREATE INDEX "signal_node_id_676fb766" ON "signal" ("node_id");
CREATE INDEX "signal_rexcore_id_35df7551" ON "signal" ("rexcore_id");
CREATE INDEX "signal_tblspace_id_285afc6f" ON "signal" ("tblspace_id");
ALTER TABLE "datatbl" ADD CONSTRAINT "datatbl_tblspace_id_f4d2c0d4_fk_tblspace_id" FOREIGN KEY ("tblspace_id") REFERENCES "tblspace" ("id") DEFERRABLE INITIALLY DEFERRED;
CREATE INDEX "datatbl_tblspace_id_f4d2c0d4" ON "datatbl" ("tblspace_id");
ALTER TABLE "signal_grp" ADD CONSTRAINT "signal_grp_signal_id_grp_id_5a5f00ff_uniq" UNIQUE ("signal_id", "grp_id");
ALTER TABLE "signal_grp" ADD CONSTRAINT "signal_grp_signal_id_3edb8de8_fk_signal_id" FOREIGN KEY ("signal_id") REFERENCES "signal" ("id") DEFERRABLE INITIALLY DEFERRED;
ALTER TABLE "signal_grp" ADD CONSTRAINT "signal_grp_grp_id_c919211f_fk_grp_id" FOREIGN KEY ("grp_id") REFERENCES "grp" ("id") DEFERRABLE INITIALLY DEFERRED;
CREATE INDEX "signal_grp_grp_id_c919211f" ON "signal_grp" ("grp_id");
COMMIT;
