from api_base.core.dynamic_import import dynamic_import

from .core import Export


class NodeSheet(Export):
    def __init__(self, provider, nodes):
        super().__init__(provider)
        self.nodes = nodes

    def create_sheet(self, workbook):
        sheet = workbook.create_sheet(title="NODE")

        headers = [
            "id",
            "name",
            "description",
            "connection",
        ]

        self.write_header(sheet, headers)

        row = 1
        nodes = self.nodes
        for node in nodes:
            row = row + 1
            sheet.cell(column=1, row=row, value=node.id)
            sheet.cell(column=2, row=row, value=node.name)
            sheet.cell(column=3, row=row, value=node.description)
            sheet.cell(column=4, row=row, value=node.connection)


class SignalSheet(Export):
    def __init__(self, provider, signals):
        super().__init__(provider)
        self.signals = signals

    def create_sheet(self, workbook):
        sheet = workbook.create_sheet(title="SIGNAL")

        headers = [
            "id",
            "node",
            "tblspace",
            "name",
            "description",
            "comment",
            "type",
            "unit",
            "decimals",
            "aggregation",
            "connection",
            "rexcore",
            "rex_value_path",
            "rex_trend_path",
            "range_min",
            "range_max",
        ]

        self.write_header(sheet, headers)

        row = 1
        signals = self.signals
        for signal in signals:
            row = row + 1

            sheet.cell(column=1, row=row, value=signal.id)
            sheet.cell(column=2, row=row, value=signal.node_id)
            sheet.cell(column=3, row=row, value=signal.tblspace_id)
            sheet.cell(column=4, row=row, value=signal.name)
            sheet.cell(column=5, row=row, value=signal.description)
            sheet.cell(column=6, row=row, value=signal.comment)
            sheet.cell(column=7, row=row, value=signal.type)
            sheet.cell(column=8, row=row, value=signal.unit)
            sheet.cell(column=9, row=row, value=signal.decimals)
            sheet.cell(column=10, row=row, value=signal.aggregation)
            sheet.cell(column=11, row=row, value=signal.connection)
            sheet.cell(column=12, row=row, value=signal.rexcore_id)
            sheet.cell(column=13, row=row, value=signal.rex_value_path)
            sheet.cell(column=14, row=row, value=signal.rex_trend_path)
            sheet.cell(column=15, row=row, value=signal.range_min)
            sheet.cell(column=16, row=row, value=signal.range_max)
