from rest_framework import serializers


class GroupSerializer(serializers.Serializer):
    id = serializers.IntegerField()
    name = serializers.CharField()
    description = serializers.CharField()


class RexCoreSerializer(serializers.Serializer):
    id = serializers.IntegerField()
    name = serializers.CharField()
    description = serializers.CharField()
    connection = serializers.CharField()
    username = serializers.CharField()


class SignalSerializer(serializers.Serializer):
    id = serializers.IntegerField()
    name = serializers.CharField()
    name_show = serializers.CharField(allow_blank=True, allow_null=True)
    description = serializers.CharField()
    type = serializers.CharField()
    unit = serializers.CharField()
    decimals = serializers.IntegerField()
    rexcore_id = serializers.IntegerField()
    rexcore = RexCoreSerializer(read_only=True)
    rex_value_path = serializers.CharField()
    rex_trend_path = serializers.CharField()
    range_min = serializers.FloatField()
    range_max = serializers.FloatField()
    groups = GroupSerializer(many=True, read_only=True)


class SignalGroupSerializer(serializers.Serializer):
    id = serializers.IntegerField()
    name = serializers.CharField()
    description = serializers.CharField()


class SignalDataValueSerializer(serializers.Serializer):
    dt = serializers.DateTimeField()
    value = serializers.FloatField()
    value_min = serializers.FloatField()
    value_max = serializers.FloatField()
    quality = serializers.FloatField()

    level = serializers.IntegerField()
    cnt = serializers.IntegerField()
