import datetime

from django.test import TestCase

from ...core.aggregation_helpers import window_fn


class AggregationHelpersTestCase(TestCase):

    def test_window_fn_1(self):
        dt_start = datetime.datetime(2021, 1, 1, 0, 0)
        time = datetime.datetime(2021, 1, 2, 0, 0) # 1 day = 86400 seconds
        window_segment = 100

        window_index = window_fn(time, dt_start, window_segment)
        self.assertEqual(window_index, 864)

    def test_window_fn_2(self):
        dt_start = datetime.datetime(2021, 1, 1, 0, 0)
        time = datetime.datetime(2021, 1, 8, 0, 0) # 7 day = 604800 seconds
        window_segment = 1920 # width of HD resolution

        window_index = window_fn(time, dt_start, window_segment)
        self.assertEqual(window_index, 315)
