import datetime

from django.test import TestCase

from ...core.cumulative_preprocessor import CumulativePreprocessor


class CumulativePreprocessorTestCase(TestCase):

    def test_cumulative_preprocessor(self):
        context = {
            'dt_start': datetime.datetime(2021, 1, 1, 0, 0),
            'dt_end': datetime.datetime(2021, 1, 31, 0, 0),
            'level': None,
            'aggregation': 60*24*7,
        }

        data = [[
            datetime.datetime(2021, 1, 1, 0, 0),
            100.00,
            50.00,
            150.00,
            1.00,
        ], [
            datetime.datetime(2021, 1, 8, 0, 0),
            150.00,
            100.00,
            200.00,
            1.00,
        ]]

        preprocessor = CumulativePreprocessor()
        preprocessor.process(context, data)

        window_level, values = preprocessor.result()

        #self.maxDiff = None
        #self.assertEqual(window_level, 0)
        #self.assertEqual(values, [{
        #    'cnt': 1,
        #    'dt': datetime.datetime(2021, 1, 1, 0, 0),
        #    'level': 0,
        #    'quality': 1.0,
        #    'value': 100.0,
        #    'value_max': 150.0,
        #    'value_min': 50.0,
        #}, {
        #    'cnt': 1,
        #    'dt': datetime.datetime(2021, 1, 1, 23, 13, 33),
        #    'level': 1,
        #    'quality': 1.0,
        #    'value': 150.0,
        #    'value_max': 200.0,
        #    'value_min': 100.0,
        #}, {
        #    'cnt': 1,
        #    'dt': datetime.datetime(2021, 1, 1, 23, 13, 33),
        #    'level': 1,
        #    'quality': 1.0,
        #    'value': 150.0,
        #    'value_max': 200.0,
        #    'value_min': 100.0,
        #}, {
        #    'cnt': 1,
        #    'dt': datetime.datetime(2021, 1, 1, 23, 13, 33),
        #    'level': 1,
        #    'quality': 1.0,
        #    'value': 150.0,
        #    'value_max': 200.0,
        #    'value_min': 100.0,
        #}, {
        #    'cnt': 1,
        #    'dt': datetime.datetime(2021, 1, 1, 23, 13, 33),
        #    'level': 1,
        #    'quality': 1.0,
        #    'value': 150.0,
        #    'value_max': 200.0,
        #    'value_min': 100.0,
        #}, {
        #    'cnt': 1,
        #    'dt': datetime.datetime(2021, 1, 1, 23, 13, 33),
        #    'level': 1,
        #    'quality': 1.0,
        #    'value': 150.0,
        #    'value_max': 200.0,
        #    'value_min': 100.0,
        #}])

    def prepare_context(self, context):
        dt_start = context['dt_start']
        dt_end = context['dt_end']
        level = context['level']

        dt_diff = dt_end - dt_start
        dt_diff_seconds = dt_diff.total_seconds()

        window_segment = int(dt_diff_seconds / level) + 1 # TODO MM move into helper function
        context['window_segment'] = window_segment

        return context
