from django.urls import path


def urlpatterns_factory(views):
    return [
        path('signal/', views.SignalList.as_view()),
        path('signal/<int:signal_pk>/', views.SignalDetail.as_view()),
        path('signal/<int:signal_pk>/group/', views.SignalGroupsList.as_view()),
        path('signal/<int:signal_pk>/data/', views.SignalDataAutoView.as_view()),
        path('signal/<int:signal_pk>/data/as/analog/', views.SignalDataAnalogView.as_view()),
        path('signal/<int:signal_pk>/data/as/bar/', views.SignalDataBarView.as_view()),
        path('signal/<int:signal_pk>/data/as/cumulative/', views.SignalDataCumulativeView.as_view()),
        path('signal/<int:signal_pk>/data/as/bool/', views.SignalDataBoolView.as_view()),
        path('signal/batch/last-value/', views.BatchSignalLastValue.as_view()),

        path('group/', views.GroupList.as_view()),
        path('group/<int:group_pk>/', views.GroupDetail.as_view()),

        path('rex-connection/', views.RexCoreList.as_view()),
        path('rex-connection/<int:connection_pk>/', views.RexCoreDetail.as_view()),

        path('option/', views.Option.as_view()),

        path('version/', views.Version.as_view()),

        path('export/', views.Export.as_view()),
    ]
