from django.conf import settings

import api_database.models as base_models


class Data(base_models.Data):
    class Meta:
        abstract = True


class Datatbl(base_models.Datatbl):
    class Meta:
        proxy = True
        managed = True
        db_table = 'datatbl'


class Grp(base_models.Grp):
    class Meta:
        proxy = True
        managed = True
        db_table = 'grp'


class Node(base_models.Node):
    class Meta:
        proxy = True
        managed = True
        db_table = 'node'


class Rexcore(base_models.Rexcore):
    class Meta:
        proxy = True
        managed = True
        db_table = 'rexcore'


class Signal(base_models.Signal):
    class Meta:
        proxy = True
        managed = True
        db_table = 'signal'


class SignalGrp(base_models.SignalGrp):
    class Meta:
        proxy = True
        managed = True
        db_table = 'signal_grp'


class Tblspace(base_models.Tblspace):
    class Meta:
        proxy = True
        managed = True
        db_table = 'tblspace'


# data models are generated automatically
base_models.create_data_models(
    Data,
    settings.APP_DATATABLE_BEGIN,
    settings.APP_DATATABLE_END
)
