###############################################################################
SIZEOF_XBYTE = 1
SIZEOF_XWORD = 2
SIZEOF_XDWORD = 4
SIZEOF_XSHORT = 2
SIZEOF_XLONG = 4
SIZEOF_XFLOAT = 4
SIZEOF_XDOUBLE = 8
SIZEOF_XTIME = 8
SIZEOF_XLARGE = 8
SIZEOF_XERROR = 2

GROUP_ITEM_SIZES = [
    1,
    SIZEOF_XBYTE,
    SIZEOF_XSHORT,
    SIZEOF_XLONG,
    SIZEOF_XWORD,
    SIZEOF_XDWORD,
    SIZEOF_XFLOAT,
    SIZEOF_XDOUBLE,
    SIZEOF_XTIME,
    SIZEOF_XLARGE,
    SIZEOF_XERROR,
]

###############################################################################
XR_OK = 0

XR_AR_INTEGRITY_ERROR = -606
XR_AR_NO_MORE_ITEMS = -10

ALL_INTEGRITY_ERROR = 4

###############################################################################
MINIMAL_REM_COUNT = 512
BUFFER_SIZE = 4096

###############################################################################
SOF_ALARMID = SIZEOF_XWORD
SOF_LEVEL = SIZEOF_XBYTE
SOF_CODE = SIZEOF_XBYTE
SOF_TSTAMP = (SIZEOF_XWORD + SIZEOF_XDWORD)

SOF_TSTAMP_CODE = (SOF_TSTAMP + SOF_CODE)
SOF_LEVEL_ALARMID = (SOF_LEVEL + SOF_ALARMID)
SOF_TCLI = (SOF_TSTAMP_CODE + SOF_LEVEL_ALARMID)
SOF_TCNI = SOF_TCLI

SIZEOF_SYSTEM_ALARM = (SOF_TSTAMP + SOF_CODE + SOF_LEVEL)
SIZEOF_BOOL_ALARM = (SOF_TCLI)
SIZEOF_BYTE_ALARM = (SOF_TCLI + 1)  # sizeof(XBYTE)
SIZEOF_SHORT_ALARM = (SOF_TCLI + 1)  # sizeof(XSHORT)
SIZEOF_LONG_ALARM = (SOF_TCLI + 1)  # sizeof(XLONG)
SIZEOF_WORD_ALARM = (SOF_TCLI + 1)  # sizeof(XWORD)
SIZEOF_DWORD_ALARM = (SOF_TCLI + 2)  # sizeof(XDWORD)
SIZEOF_FLOAT_ALARM = (SOF_TCLI + 2)  # sizeof(XFLOAT)
SIZEOF_DOUBLE_ALARM = (SOF_TCLI + 2)  # sizeof(XDOUBLE)
SIZEOF_TIME_ALARM = (SOF_TCLI + 2)  # sizeof(XTIME)
SIZEOF_LARGE_ALARM = (SOF_TCLI + 2)  # sizeof(XLARGE)
SIZEOF_ERROR_ALARM = (SOF_TCLI + 2)  # sizeof(XERROR)
SIZEOF_STRING_ALARM = (SOF_TCLI)

ALARM_SIZES = [
    SIZEOF_SYSTEM_ALARM,
    SIZEOF_BOOL_ALARM,
    SIZEOF_BYTE_ALARM,
    SIZEOF_SHORT_ALARM,
    SIZEOF_LONG_ALARM,
    SIZEOF_WORD_ALARM,
    SIZEOF_DWORD_ALARM,
    SIZEOF_FLOAT_ALARM,
    SIZEOF_DOUBLE_ALARM,
    SIZEOF_TIME_ALARM,
    SIZEOF_LARGE_ALARM,
    SIZEOF_ERROR_ALARM,
    SIZEOF_STRING_ALARM,
]

###############################################################################
XATC_UNKNOWN = 0
XATC_XBOOL = 1
XATC_XBYTE = 2
XATC_XSHORT = 3
XATC_XLONG = 4
XATC_XWORD = 5
XATC_XDWORD = 6
XATC_XFLOAT = 7
XATC_XDOUBLE = 8
XATC_XTIME = 9
XATC_XLARGE = 10
XATC_XERROR = 11
XATC_XSTRING = 12
XATC_XINTPTR = 13
XATC_LAST = XATC_XINTPTR
XATC_XANY_VAR = 0x0F

ARC_SYSTEM_ALARM = 0
ARC_GROUP_BASE = 16
ARC_ALARM_ACKN = 31
ARC_BOOL_ALARM = XATC_XBOOL
ARC_ERROR_ALARM = XATC_XERROR
ARC_BYTE_ALARM = XATC_XBYTE
ARC_SHORT_ALARM = XATC_XSHORT
ARC_LONG_ALARM = XATC_XLONG
ARC_WORD_ALARM = XATC_XWORD
ARC_DWORD_ALARM = XATC_XDWORD
ARC_FLOAT_ALARM = XATC_XFLOAT
ARC_DOUBLE_ALARM = XATC_XDOUBLE
ARC_TIME_ALARM = XATC_XTIME
ARC_LARGE_ALARM = XATC_XLARGE

ARC_STRING_ALARM = XATC_XSTRING
ARC_BOOL_GROUP = (ARC_BOOL_ALARM + ARC_GROUP_BASE)
ARC_ERROR_GROUP = (ARC_ERROR_ALARM + ARC_GROUP_BASE)
ARC_BYTE_GROUP = (ARC_BYTE_ALARM + ARC_GROUP_BASE)
ARC_SHORT_GROUP = (ARC_SHORT_ALARM + ARC_GROUP_BASE)
ARC_LONG_GROUP = (ARC_LONG_ALARM + ARC_GROUP_BASE)
ARC_WORD_GROUP = (ARC_WORD_ALARM + ARC_GROUP_BASE)
ARC_DWORD_GROUP = (ARC_DWORD_ALARM + ARC_GROUP_BASE)
ARC_FLOAT_GROUP = (ARC_FLOAT_ALARM + ARC_GROUP_BASE)
ARC_DOUBLE_GROUP = (ARC_DOUBLE_ALARM + ARC_GROUP_BASE)
ARC_TIME_GROUP = (ARC_TIME_ALARM + ARC_GROUP_BASE)
ARC_LARGE_GROUP = (ARC_LARGE_ALARM + ARC_GROUP_BASE)

ARC_ALARM_FIRST = ARC_SYSTEM_ALARM
ARC_ALARM_LAST = ARC_STRING_ALARM
ARC_GROUP_FIRST = ARC_BOOL_GROUP
ARC_GROUP_LAST = ARC_ERROR_GROUP

ARC_CLASS_MASK = 0x1F
ARC_CLASS_LAST = ARC_ALARM_ACKN

###############################################################################
ATF_DATE_MARK_FLAG = 0x8000

###############################################################################
ARS_DATE_MARK = 0
ARS_ARC_EVENTS = 2
ARS_SUBTYPE_SHIFT = 5
ARS_LAST = 7

ARS_SUBTYPE_MASK = 0xE0

###############################################################################
AGS_MAX_DATA_SIZE = 512  # /* bytes */

AGS_BOOL_ARR_SIZE = 32  # /* 32 bytes = 256 bits */
AGS_BYTE_ARR_SIZE = int(AGS_MAX_DATA_SIZE / SIZEOF_XBYTE)
AGS_SHORT_ARR_SIZE = int(AGS_MAX_DATA_SIZE / SIZEOF_XSHORT)
AGS_LONG_ARR_SIZE = int(AGS_MAX_DATA_SIZE / SIZEOF_XLONG)
AGS_WORD_ARR_SIZE = int(AGS_MAX_DATA_SIZE / SIZEOF_XWORD)
AGS_DWORD_ARR_SIZE = int(AGS_MAX_DATA_SIZE / SIZEOF_XDWORD)
AGS_LARGE_ARR_SIZE = int(AGS_MAX_DATA_SIZE / SIZEOF_XLARGE)
AGS_FLOAT_ARR_SIZE = int(AGS_MAX_DATA_SIZE / SIZEOF_XFLOAT)
AGS_DOUBLE_ARR_SIZE = int(AGS_MAX_DATA_SIZE / SIZEOF_XDOUBLE)
AGS_TIME_ARR_SIZE = int(AGS_MAX_DATA_SIZE / SIZEOF_XTIME)
AGS_LARGE_ARR_SIZE = int(AGS_MAX_DATA_SIZE / SIZEOF_XLARGE)
AGS_ERROR_ARR_SIZE = int(AGS_MAX_DATA_SIZE / SIZEOF_XERROR)

###############################################################################
ALAL_LEVEL_DIVISOR = 10
DESC_ARR_LEN = 7
OSTM_NANOSEC_PER_DAY = 86400000000000
CAL_ORIG_YEAR = 2000

###############################################################################
CLASS_NAMES = [
    "System",  # 0
    "AlBool",  # 1
    "AlByte",  # 2
    "AlShort",  # 3
    "AlLong",  # 4
    "AlWord",  # 5
    "AlDWord",  # 6
    "AlFloat",  # 7
    "AlDouble",  # 8
    "AlTime",  # 9
    "AlLarge",  # 10
    "AlError",  # 11
    "AlString",  # 12
    "-Res 13-",  # 13
    "-Res 14-",  # 14
    "-Res 15-",  # 15
    "-Res 16-",  # 16
    "GrBool",  # 17
    "GrByte",  # 18
    "GrShort",  # 19
    "GrLong",  # 20
    "GrWord",  # 21
    "GrDWord",  # 22
    "GrFloat",  # 23
    "GrDouble",  # 24
    "GrTime",  # 25
    "GrLarge",  # 26
    "GrError",  # 27
    "-Res 28-",  # 28
    "-Res 29-",  # 29
    "-Res 30-",  # 30
    "AlAckn",  # 31
    "????????",  # 32
]

SYSTEM_SUBTYPES = [
    "Date Mark",
    "Executive events",
    "Archive events",
    "????",
]

BOOL_SUBTYPES = [
    "H->L",
    "L->H",
    "?2??",
    "?3??",
    "?4??",
    "?5??",
    "?6??",
    "?7??",
    "????",
]

VAL_SUBTYPES_SHORT = [
    "Lo",
    "Hi",
    "LoLo",
    "HiHi",
    "data",
    "?5??",
    "?6??",
    "?7??",
    "????",
]

STR_AL_SUBTYPES = [
    "Norm",
    "LogF",
    "Arch",
    "User",
    "?4??",
    "?5??",
    "?6??",
    "SYST",
    "????",
]

VAL_SUBTYPES_LONG = [
    "Lo/L",
    "Hi/H",
    "LoLo",
    "HiHi",
    "?4??",
    "?5??",
    "?6??",
    "?7??",
    "????",
]
