#!/usr/bin/env python
"""Django's command-line utility for administrative tasks."""
from pathlib import Path

import os
import sys


def main():
    """Run administrative tasks."""
    
    base_dir = Path(__file__).resolve().parent.parent
    lib_dir = os.path.join(base_dir, 'lib')
    if os.path.exists(lib_dir):
        sys.path.append(lib_dir)

    os.environ.setdefault('DJANGO_SETTINGS_MODULE', '_config.bootstrap.bootstrap')

    try:
        from django.core.management import execute_from_command_line
    except ImportError as exc:
        raise ImportError(
            "Couldn't import Django. Are you sure it's installed and "
            "available on your PYTHONPATH environment variable? Did you "
            "forget to activate a virtual environment?"
        ) from exc
    execute_from_command_line(sys.argv)


if __name__ == '__main__':
    main()
