"""rex_arc_viewer URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/3.1/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""
from django.urls import include, path
from django.conf import settings
from django.shortcuts import redirect

import logging


urlpatterns = []

if hasattr(settings, 'APP_URL'):
    url_items = settings.APP_URL

    for url_path, url_item in url_items.items():
        route = settings.APP_URL_BASE_ROUTE + "/" + url_path

        if not route.endswith("/"):
            route = route + "/"

        urlpatterns += [
            path(route, include(url_item))
        ]

urlpatterns += [
    path('', lambda request: redirect(settings.APP_URL_BASE_ROUTE + "/", permanent=False)),
]
