# -*- coding: utf-8 -*-
from django.core.management.base import BaseCommand
from django.conf import settings

from os import path


class Command(BaseCommand):

    def add_arguments(self, parser):
        parser.add_argument(
            '--type',
            type=str,
            required=True,
            help='Configuration type'
        )  # TODO MM added enum types

    def handle(self, *args, **options):
        type = options['type']
        #type = "impl_" + type  # TODO MM

        settings_path = path.join(settings.BASE_DIR, "_config", type, "settings.py")

        settings_exists = path.exists(settings_path)
        
        return str(settings_exists)
