# -*- coding: utf-8 -*-
from django.core.management.base import BaseCommand
from django.db import connections
from django.conf import settings

import importlib


class Command(BaseCommand):

    def add_arguments(self, parser):
        parser.add_argument(
            '--database',
            type=str,
            required=True,
            help='Database Type'
        )

    def handle(self, *args, **options):
        database = options['database']

        impmodule = importlib.import_module("_config.db_" + database + ".settings")
        DATABASES = impmodule.DATABASES

        connections.databases[database] = DATABASES['default']
        db_conn = connections[database]

        try:
            db_conn.cursor()
        except Exception:
            connected = False
        else:
            connected = True

        return str(connected)
