# -*- coding: utf-8 -*-
from django.core.management.base import BaseCommand, CommandError
from django.db import connections
from django.conf import settings

from os import path

import uuid


class Command(BaseCommand):

    def add_arguments(self, parser):
        parser.add_argument(
            '--user',
            type=str,
            required=True,
            help='User'
        )

        parser.add_argument(
            '--password',
            type=str,
            required=True,
            help='Password'
        )

        parser.add_argument(
            '--name',
            type=str,
            required=True,
            help='Name'
        )

        parser.add_argument(
            '--schema',
            type=str,
            required=True,
            help='Schema'
        )

    def handle(self, *args, **options):
        self._create_user(options)

        return str(True)

    def _create_user(self, options):
        queries = []
        queries.append("CREATE USER #USER# WITH PASSWORD '#PASSWORD#';")
        queries.append("CREATE DATABASE #NAME# OWNER #USER#;")
        #queries.append("CREATE SCHEMA #SCHEMA# AUTHORIZATION #USER#;")
        queries.append("GRANT ALL PRIVILEGES ON DATABASE #NAME# TO #USER#;")
        queries.append("GRANT ALL PRIVILEGES ON SCHEMA #SCHEMA# TO #USER#;")

        database_id = str(uuid.uuid4())

        newDatabase = {}
        newDatabase["id"] = database_id
        newDatabase['ENGINE'] = 'django.db.backends.postgresql_psycopg2'
        newDatabase['NAME'] = 'postgres'
        newDatabase['USER'] = 'postgres'
        newDatabase['PASSWORD'] = ''
        newDatabase['HOST'] = ''
        newDatabase['PORT'] = ''
        connections.databases[database_id] = newDatabase

        with connections[database_id].cursor() as cursor:
            for query in queries:
                query = query.replace('#USER#', options["user"])
                query = query.replace('#PASSWORD#', options["password"])
                query = query.replace('#NAME#', options["name"])
                query = query.replace('#SCHEMA#', options["schema"])

                cursor.execute(query)
